// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/PointOfInterestRequest.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/point_of_interest_request__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
// Member `module_name`
#include "rosidl_runtime_c/string_functions.h"

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__init(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__init(&msg->module_name)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // request_id
  // cancel
  // update_num
  // guid_valid
  // guid
  // tolerance
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__fini(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // module_name
  rosidl_runtime_c__String__fini(&msg->module_name);
  // request_id
  // cancel
  // update_num
  // guid_valid
  // guid
  // tolerance
}

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__are_equal(const automotive_navigation_msgs__msg__PointOfInterestRequest * lhs, const automotive_navigation_msgs__msg__PointOfInterestRequest * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->module_name), &(rhs->module_name)))
  {
    return false;
  }
  // request_id
  if (lhs->request_id != rhs->request_id) {
    return false;
  }
  // cancel
  if (lhs->cancel != rhs->cancel) {
    return false;
  }
  // update_num
  if (lhs->update_num != rhs->update_num) {
    return false;
  }
  // guid_valid
  if (lhs->guid_valid != rhs->guid_valid) {
    return false;
  }
  // guid
  if (lhs->guid != rhs->guid) {
    return false;
  }
  // tolerance
  if (lhs->tolerance != rhs->tolerance) {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__copy(
  const automotive_navigation_msgs__msg__PointOfInterestRequest * input,
  automotive_navigation_msgs__msg__PointOfInterestRequest * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__copy(
      &(input->module_name), &(output->module_name)))
  {
    return false;
  }
  // request_id
  output->request_id = input->request_id;
  // cancel
  output->cancel = input->cancel;
  // update_num
  output->update_num = input->update_num;
  // guid_valid
  output->guid_valid = input->guid_valid;
  // guid
  output->guid = input->guid;
  // tolerance
  output->tolerance = input->tolerance;
  return true;
}

automotive_navigation_msgs__msg__PointOfInterestRequest *
automotive_navigation_msgs__msg__PointOfInterestRequest__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestRequest * msg = (automotive_navigation_msgs__msg__PointOfInterestRequest *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest));
  bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__destroy(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__init(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestRequest * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__PointOfInterestRequest *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__PointOfInterestRequest__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__fini(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__PointOfInterestRequest__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence *
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array = (automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__destroy(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__are_equal(const automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * lhs, const automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestRequest__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__copy(
  const automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * input,
  automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_navigation_msgs__msg__PointOfInterestRequest * data =
      (automotive_navigation_msgs__msg__PointOfInterestRequest *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__PointOfInterestRequest__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__PointOfInterestRequest__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestRequest__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
