// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from automotive_navigation_msgs:msg/RoadNetworkBoundaries.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "automotive_navigation_msgs/msg/detail/road_network_boundaries__functions.h"
#include "automotive_navigation_msgs/msg/detail/road_network_boundaries__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace automotive_navigation_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void RoadNetworkBoundaries_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) automotive_navigation_msgs::msg::RoadNetworkBoundaries(_init);
}

void RoadNetworkBoundaries_fini_function(void * message_memory)
{
  auto typed_message = static_cast<automotive_navigation_msgs::msg::RoadNetworkBoundaries *>(message_memory);
  typed_message->~RoadNetworkBoundaries();
}

size_t size_function__RoadNetworkBoundaries__road_network_boundaries(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RoadNetworkBoundaries__road_network_boundaries(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray> *>(untyped_member);
  return &member[index];
}

void * get_function__RoadNetworkBoundaries__road_network_boundaries(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray> *>(untyped_member);
  return &member[index];
}

void fetch_function__RoadNetworkBoundaries__road_network_boundaries(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const automotive_navigation_msgs::msg::LaneBoundaryArray *>(
    get_const_function__RoadNetworkBoundaries__road_network_boundaries(untyped_member, index));
  auto & value = *reinterpret_cast<automotive_navigation_msgs::msg::LaneBoundaryArray *>(untyped_value);
  value = item;
}

void assign_function__RoadNetworkBoundaries__road_network_boundaries(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<automotive_navigation_msgs::msg::LaneBoundaryArray *>(
    get_function__RoadNetworkBoundaries__road_network_boundaries(untyped_member, index));
  const auto & value = *reinterpret_cast<const automotive_navigation_msgs::msg::LaneBoundaryArray *>(untyped_value);
  item = value;
}

void resize_function__RoadNetworkBoundaries__road_network_boundaries(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RoadNetworkBoundaries_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::RoadNetworkBoundaries, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "road_network_boundaries",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<automotive_navigation_msgs::msg::LaneBoundaryArray>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::RoadNetworkBoundaries, road_network_boundaries),  // bytes offset in struct
    nullptr,  // default value
    size_function__RoadNetworkBoundaries__road_network_boundaries,  // size() function pointer
    get_const_function__RoadNetworkBoundaries__road_network_boundaries,  // get_const(index) function pointer
    get_function__RoadNetworkBoundaries__road_network_boundaries,  // get(index) function pointer
    fetch_function__RoadNetworkBoundaries__road_network_boundaries,  // fetch(index, &value) function pointer
    assign_function__RoadNetworkBoundaries__road_network_boundaries,  // assign(index, value) function pointer
    resize_function__RoadNetworkBoundaries__road_network_boundaries  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RoadNetworkBoundaries_message_members = {
  "automotive_navigation_msgs::msg",  // message namespace
  "RoadNetworkBoundaries",  // message name
  2,  // number of fields
  sizeof(automotive_navigation_msgs::msg::RoadNetworkBoundaries),
  false,  // has_any_key_member_
  RoadNetworkBoundaries_message_member_array,  // message members
  RoadNetworkBoundaries_init_function,  // function to initialize message memory (memory has to be allocated)
  RoadNetworkBoundaries_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RoadNetworkBoundaries_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RoadNetworkBoundaries_message_members,
  get_message_typesupport_handle_function,
  &automotive_navigation_msgs__msg__RoadNetworkBoundaries__get_type_hash,
  &automotive_navigation_msgs__msg__RoadNetworkBoundaries__get_type_description,
  &automotive_navigation_msgs__msg__RoadNetworkBoundaries__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace automotive_navigation_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_navigation_msgs::msg::RoadNetworkBoundaries>()
{
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::RoadNetworkBoundaries_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, automotive_navigation_msgs, msg, RoadNetworkBoundaries)() {
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::RoadNetworkBoundaries_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
